class ArcSpring
{
  float target = 0.0;
  float angle = 0.0;
  float velocity = 0.0;
  float distance = 200.0;
  float k = 0.1;
  float damping,
        mass;
  
  ArcSpring(float damping, float mass)
  {
    this.damping = damping;
    this.mass = mass;
  }
  
  ArcSpring()
  {
    this(0.95, 30.0);
  }
  
  void spinBy(float rads)
  {
    target += rads;
  }
  
  float getAngle()
  {
    return angle;
  }

  float getX()
  {
    return distance * cos(angle);
  }
  
  float getY()
  {
    return distance * sin(angle);
  }  
  
  void step()
  {
    float force = -k * (angle - target);  // f = -ky (Hooke's law)
    float accel = force / mass;           // f = ma
    
    velocity = damping * (velocity + accel);
    angle += velocity;
  }
}
